"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _utils = require("../utils");

var _deepcopy = require("deepcopy");

var _deepcopy2 = _interopRequireDefault(_deepcopy);

var _validation = require("./validation");

var _validation2 = _interopRequireDefault(_validation);

var _remove = require("./remove");

var _remove2 = _interopRequireDefault(_remove);

var _require2 = require("./require");

var _require3 = _interopRequireDefault(_require2);

var _replaceUi = require("./replaceUi");

var _replaceUi2 = _interopRequireDefault(_replaceUi);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Executor = function Executor(rules, schema) {
  var uiSchema = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var extraActions = arguments[3];

  _classCallCheck(this, Executor);

  _initialiseProps.call(this);

  this.rules = rules;
  this.schema = schema;
  this.uiSchema = uiSchema;

  this.allActions = Object.assign({}, { remove: _remove2.default, require: _require3.default, replaceUi: _replaceUi2.default }, extraActions);

  if ((0, _utils.isDevelopment)()) {
    (0, _validation2.default)(rules, this.allActions, schema, uiSchema);
  }
};

var _initialiseProps = function _initialiseProps() {
  var _this = this;

  this.run = function (actions) {
    var schema = (0, _deepcopy2.default)(_this.schema);
    var uiSchema = (0, _deepcopy2.default)(_this.uiSchema);

    actions.forEach(function (_ref) {
      var type = _ref.type,
          params = _ref.params;

      var executor = _this.allActions[type];
      executor(params, schema, uiSchema);
    });

    return Promise.resolve({ schema: schema, uiSchema: uiSchema });
  };
};

exports.default = Executor;